local science_packs =
{
    {"science-pack-1", 1},
    {"science-pack-2", 1},
    {"science-pack-3", 1},
    {"production-science-pack", 1},
    {"high-tech-science-pack", 1},
    {"space-science-pack", 1}
}

local non_combat_bobs =
{
    {"science-pack-1", 1},
    {"science-pack-2", 1},
    {"science-pack-3", 1},
    {"logistic-science-pack", 1},
    {"high-tech-science-pack", 1},
    {"space-science-pack", 1}
}

if data.raw.item["logistic-science-pack"] then science_packs = non_combat_bobs end

data:extend({

    {
        type = "technology",
        name = "worker-robots-storage-4",
        icon = "__base__/graphics/technology/worker-robots-storage.png",
        effects = {{type = "worker-robot-storage", modifier = 1}},
        prerequisites = {"worker-robots-storage-3"},
        unit = {count_formula = "100(L-1)", ingredients = science_packs, time = 60},
        max_level = "infinite",
        upgrade = true,
        order = "c-k-g-c"
    },


    {
        type = "technology",
        name = "inserter-capacity-bonus-8",
        icon = "__base__/graphics/technology/inserter-capacity.png",
        effects = {{type = "stack-inserter-capacity-bonus", modifier = 2}},
        prerequisites = {"inserter-capacity-bonus-7"},
        unit = {count_formula = "100(L-1)", ingredients = science_packs, time = 60},
        max_level = "infinite",
        upgrade = true,
        order = "c-o-h"
    },

    {
        type = "technology",
        name = "character-logistic-trash-slots-3",
        icon = "__base__/graphics/technology/character-logistic-trash-slots.png",
        effects = {{type = "character-logistic-trash-slots", modifier = 6}},
        prerequisites = {"character-logistic-trash-slots-2"},
        unit = {count_formula = "100(L-1)", ingredients = science_packs, time = 60},
        max_level = "6",
        upgrade = true,
        order = "c-k-f-b"
    },

    {
        type = "technology",
        name = "braking-force-8",
        icon = "__base__/graphics/technology/braking-force.png",
        effects =
        {{type = "train-braking-force-bonus", modifier = 0.15}},
        prerequisites = {"braking-force-7"},
        unit = {count_formula = "100(L-1)", ingredients = science_packs, time = 60},
        max_level = "infinite",
        upgrade = true,
        order = "b-f-g"
    },

    {
        type = "technology",
        name = "research-speed-7",
        icon = "__base__/graphics/technology/research-speed.png",
        effects = {{type = "laboratory-speed", modifier = 1}},
        prerequisites = {"research-speed-6"},
        unit = {count_formula = "100(L-1)", ingredients = science_packs, time = 60},
        max_level = "infinite",
        upgrade = true,
        order = "c-m-d"
    }

})

if not data.raw.technology["bob-robo-modular-1"] then
    
    data:extend({

        {
            type = "technology",
            name = "character-logistic-slots-7",
            icon = "__base__/graphics/technology/character-logistic-slots.png",
            effects = {{type = "character-logistic-slots", modifier = 6}},
            prerequisites = {"character-logistic-slots-6"},
            unit = {count_formula = "100(L-1)", ingredients = science_packs, time = 60},
            max_level = "15",
            upgrade = true,
            order = "c-k-e-f"
        },

        {
            type = "technology",
            name = "character-inventory-slots-8",
            icon = "__base__/graphics/technology/toolbelt.png",
            effects = {{type = "character-inventory-slots-bonus", modifier = 10}},
            prerequisites = {"character-inventory-slots-7"},
            unit = {count_formula = "100(L-1)", ingredients = science_packs, time = 60},
            max_level = "infinite",
            upgrade = true,
            order = "c-m-d"
        }

    })

    else

    data.raw.technology["character-inventory-slots-4"].max_level = "infinite"
    data.raw.technology["character-logistic-slots-10"].max_level = 15

end